Subject: Re: [PATCH net-next] sfc: fix XDP-redirect in this driver

From: Jesper Dangaard Brouer <[email-masked]>
Date: Mon, 16 Mar 2020 12:55:07 +0100

On Mon, 16 Mar 2020 13:45:23 +0300
Denis Kirjanov <[email-masked]> wrote:

> On 3/16/20, Jesper Dangaard Brouer <[email-masked]> wrote:
> > On Mon, 16 Mar 2020 10:10:01 +0000
> > Edward Cree <[email-masked]> wrote:
> >  
> >> On 16/03/2020 08:49, David Miller wrote:  
> >> > Solarflare folks, please review.  
> >>
> >> This looks like a correct implementation of what it purports to do, so
> >> Acked-by: Edward Cree <[email-masked]>  
> >
> > Thanks for the review!
> >  
> >> It did take me some digging to understand _why_ it was needed though;
> >>  Jesper, is there any documentation of the tailroom requirement?  It
> >>  doesn't seem to be mentioned anywhere I could find.  
> >
> > I admit that is is poorly documented.  It is a requirement as both
> > cpumap and veth have a dependency when they process the redirected
> > packet.  We/I also need to update the doc on one page per packet
> > requirement, as it is (in-practice) no longer true.  
> 
> Hi Jesper,
> 
> that means that's on-going work to add multi-buffer/page support to XDP, right?

Yes, it seems that both Amazon and Google have a need for this.

Do notice that there is a fair amount of work-ahead.  I'm working on
establishing a frame size/end, such that we can get reserved storage
space for multi-buffer references/segments[3].  I know Samih from
Amazon is working on the multi-buffer part of using this area.
 
> >
> > I'm noticing these bugs, because I'm working on a patchset that add
> > tailroom extend, and also reserves this 'skb_shared_info' tailroom area.
> > The real goal is to later add XDP multi-buffer support, using this
> > 'skb_shared_info' tailroom area, as desc here[2]
> >
> > [2]
> > https://github.com/xdp-project/xdp-project/blob/master/areas/core/xdp-multi-buffer01-design.org

[3] https://github.com/xdp-project/xdp-project/blob/master/areas/core/xdp-multi-buffer01-design.org#storage-space-for-multi-buffer-referencessegments
-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer